/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.baselibs;

import cdac.medinfo.sdk.hl7282.baselibs.segmentfactory.DataElementFactory;
import cdac.medinfo.sdk.hl7282.commoninterface.IDataType;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidComponentTypeException;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidDataTypeException;
import cdac.medinfo.sdk.hl7282.exceptions.MissingValueException;
import cdac.medinfo.sdk.hl7282.utils.EnumDataType;
import cdac.medinfo.sdk.hl7282.utils.IDataTypeMap;

/**
 * MSG - Message Type<p>
 * This field contains the message type, trigger event, and the message structure ID for the message.
 * <p>Represents an HL7 MSG data type. 
 * This data type has the following attributes:</p><p>
 *  1. Message Code (ID)<b>Required</b><br>
 *  2. Trigger Event (ID)<b>Required</b><br>
 *  3. Message Structure (ID)<b>Required</b><br><p>
 * This class provides accessors & mutators for the elements mentioned above.
 * This class override the equal method, to check whether some other object is "equal to" this one.
 * 
 * <p>User can also create Data Type through {@link DataElementFactory} 
 */
public class MSG extends CompositeDataType    
{
	


	/**
	 * Default Constructor for MSG
	 */
	public MSG()
	{
		super(EnumDataType.HL7_DT_MSG);
		 
	}

	/**
	 * Constructor  for MSG class which takes four arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */ 
	public MSG(int iMinLength, int iMaxLength, String strCLength,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_MSG);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}

	/**
	 * Constructor for MSG class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MSG(int iMinLength, int iMaxLength, String strCLength,int iTableNo,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_MSG);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iTableNo = iTableNo;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());		
		}
	}
	/**
	 * Constructor for MSG class which takes two arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MSG(int iComponentType,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_MSG);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for MSG class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MSG(int iComponentType,int iMinLength, int iMaxLength, String strCLength,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_MSG);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for MSG class which takes six arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MSG(int iComponentType,int iMinLength, int iMaxLength, String strCLength,int ITableNo,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_MSG);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iTableNo = ITableNo;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}



	/**
	 *Sets the MessageCode.
	 *@param strMessageCode Specifies the message type code.Suggested values such as ACK, ADT, ORM, ORU etc. 
	 */
	public void setMessageCode(String strMessageCode)
	{
		if(strMessageCode!=null)
			setComponentType(1, strMessageCode);
		else
			setMessageCode((ID)null);
	}


	/**
	 *Sets the MessageCode.
	 *@param ID Specifies the message type code.Suggested values such as ACK, ADT, ORM, ORU etc.
	 */
	public void setMessageCode(ID objID)
	{
		setComponentType(1,objID);
	}

	/**
	 *Sets the TriggerEvent.
	 *@param strTriggerEvent Specifies the trigger event code.  
	 */
	public void setTriggerEvent(String strTriggerEvent)
	{
		if(strTriggerEvent!=null)
			setComponentType(2, strTriggerEvent);
		else
			setTriggerEvent((ID)null);
	}

	/**
	 *Sets the TriggerEvent.
	 *@param objID Specifies the trigger event code. 
	 */
	public void setTriggerEvent(ID objID)
	{
		setComponentType(2,objID);
	}

	/**
	 *Sets the MessageStructure.
	 *@param strMessageStructure Specifies the abstract message structure code. 
	 */
	public void setMessageStructure(String strMessageStructure)
	{
		if(strMessageStructure!=null)
			setComponentType(3, strMessageStructure);
		else
			setMessageStructure((ID)null);
	}

	/**
	 *Sets the MessageStructure.
	 *@param objID Specifies the abstract message structure code.
	 */
	public void setMessageStructure(ID objID)
	{
		setComponentType(3,objID);
	}
	/**
	 * The method gives the object of Tye ID
	 * @return ID - data type.
	 */
	public ID getMessageCode()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(1);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}
	/**
	 * The method gives the object of Tye ID
	 * @return ID - data type.
	 */
	public ID getTriggerEvent()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(2);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * The method gives the object of Tye ID
	 * @return ID - data type.
	 */
	public ID getMessageStructure()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(3);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}
	/**
	 * The Method validates the Input value,and if validated properly then returns true.
	 * Here the validetion is based on the compulsory fields for the Datatype. 
	 * @return boolean - true or false.
	 * @throws InvalidDataTypeException - if Invalid values is entered or Mandatory field is missing.
	 */
	public boolean validate() throws InvalidDataTypeException
	{
		super.validate();
		if(getComponentType(1)==null)
		{
			throw new MissingValueException(this.getClass().getSimpleName() + "Message Code");
		}	
		if(getComponentType(2)==null )
		{
			throw new MissingValueException(this.getClass().getSimpleName() + "Trigger Event");
		}	
		if(getComponentType(3)==null)
		{
			throw new MissingValueException(this.getClass().getSimpleName() + "Message Structure");
		}		
		else
			return true;
	}

	/**
	 * This method checks the equality of Object.
	 * @param objObject object of Object class.
	 * @return boolean - shows success or failure of the comparison.
	 */
	public boolean equals(Object objObject)
	{
		if((objObject == null ) || (!(objObject instanceof MSG)))
			return false;

		if(this.getMessageCode() == null)
		{
			if(((MSG)objObject).getMessageCode() != null)
				return false;
		}
		else if(false == (this.getMessageCode().equals(((MSG)objObject).getMessageCode())))
			return false;

		if(this.getTriggerEvent() == null)
		{
			if(((MSG)objObject).getTriggerEvent() != null)
				return false;
		}
		else if(false == (this.getTriggerEvent().equals(((MSG)objObject).getTriggerEvent())))
			return false;

		if(this.getMessageStructure() == null)
		{
			if(((MSG)objObject).getMessageStructure() != null)
				return false;
		}
		else if(false == (this.getMessageStructure().equals(((MSG)objObject).getMessageStructure())))
			return false;

		return true;
	}
}
